/* account_action.c generated by valac, the Vala compiler
 * generated from account_action.vala, do not modify */

/* account_action.vala
 *
 * Copyright (C) 2009-2010  troorl
 * Copyright (C) 2010 Kushal Das <kushal@fedoraproject.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_ACCOUNT_ACTION (account_action_get_type ())
#define ACCOUNT_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT_ACTION, AccountAction))
#define ACCOUNT_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT_ACTION, AccountActionClass))
#define IS_ACCOUNT_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT_ACTION))
#define IS_ACCOUNT_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT_ACTION))
#define ACCOUNT_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT_ACTION, AccountActionClass))

typedef struct _AccountAction AccountAction;
typedef struct _AccountActionClass AccountActionClass;
typedef struct _AccountActionPrivate AccountActionPrivate;

#define AUTH_TYPE_ACCOUNTS (auth_accounts_get_type ())
#define AUTH_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUTH_TYPE_ACCOUNTS, AuthAccounts))
#define AUTH_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUTH_TYPE_ACCOUNTS, AuthAccountsClass))
#define AUTH_IS_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUTH_TYPE_ACCOUNTS))
#define AUTH_IS_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUTH_TYPE_ACCOUNTS))
#define AUTH_ACCOUNTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUTH_TYPE_ACCOUNTS, AuthAccountsClass))

typedef struct _AuthAccounts AuthAccounts;
typedef struct _AuthAccountsClass AuthAccountsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define AUTH_TYPE_ACCOUNT (auth_account_get_type ())
#define AUTH_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUTH_TYPE_ACCOUNT, AuthAccount))
#define AUTH_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUTH_TYPE_ACCOUNT, AuthAccountClass))
#define AUTH_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUTH_TYPE_ACCOUNT))
#define AUTH_IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUTH_TYPE_ACCOUNT))
#define AUTH_ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUTH_TYPE_ACCOUNT, AuthAccountClass))

typedef struct _AuthAccount AuthAccount;
typedef struct _AuthAccountClass AuthAccountClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;

struct _AccountAction {
	GtkAction parent_instance;
	AccountActionPrivate * priv;
};

struct _AccountActionClass {
	GtkActionClass parent_class;
};

struct _AccountActionPrivate {
	AuthAccounts* accounts;
	GtkMenuItem* menu_item;
	GtkMenu* menu;
};

struct _Block1Data {
	int _ref_count_;
	AccountAction * self;
	AuthAccount* acc;
	GtkRadioMenuItem* item;
};


static gpointer account_action_parent_class = NULL;

GType account_action_get_type (void);
GType auth_accounts_get_type (void);
#define ACCOUNT_ACTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ACCOUNT_ACTION, AccountActionPrivate))
enum  {
	ACCOUNT_ACTION_DUMMY_PROPERTY
};
AccountAction* account_action_new (GtkMenuItem* m);
AccountAction* account_action_construct (GType object_type, GtkMenuItem* m);
AuthAccounts* auth_accounts_new (void);
AuthAccounts* auth_accounts_construct (GType object_type);
static void account_action_setup (AccountAction* self);
void account_action_set_ui (AccountAction* self, AuthAccounts* _ac);
GType auth_account_get_type (void);
GeeArrayList* auth_accounts_get_accounts (AuthAccounts* self);
const char* auth_account_get_login (AuthAccount* self);
const char* auth_account_get_service (AuthAccount* self);
gboolean auth_account_get_active (AuthAccount* self);
void auth_accounts_set_active_account (AuthAccounts* self, const char* hash);
const char* auth_account_get_proxy (AuthAccount* self);
const char* auth_account_get_password (AuthAccount* self);
void auth_accounts_write (AuthAccounts* self);
static void _lambda0_ (Block1Data* _data1_);
static void __lambda0__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender, gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
AuthAccount* auth_accounts_get_current_account (AuthAccounts* self);
static void _lambda1_ (AccountAction* self);
static void __lambda1__auth_accounts_changed (AuthAccounts* _sender, const char* hash, gpointer self);
void account_action_acc_changed (AccountAction* self);
static void _account_action_acc_changed_auth_accounts_active_changed (AuthAccounts* _sender, gpointer self);
void account_action_set_accounts (AccountAction* self, AuthAccounts* _accounts);
static void account_action_finalize (GObject* obj);


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


AccountAction* account_action_construct (GType object_type, GtkMenuItem* m) {
	GParameter * __params;
	GParameter * __params_it;
	AccountAction * self;
	GtkMenuItem* _tmp0_;
	g_return_val_if_fail (m != NULL, NULL);
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
	__params_it->name = "name";
	g_value_init (&__params_it->value, G_TYPE_STRING);
	g_value_set_string (&__params_it->value, "AccountAct");
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	gtk_action_set_label ((GtkAction*) self, _ ("Accounts"));
	gtk_action_set_tooltip ((GtkAction*) self, NULL);
	gtk_action_set_stock_id ((GtkAction*) self, NULL);
	self->priv->menu_item = (_tmp0_ = _g_object_ref0 (m), _g_object_unref0 (self->priv->menu_item), _tmp0_);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


AccountAction* account_action_new (GtkMenuItem* m) {
	return account_action_construct (TYPE_ACCOUNT_ACTION, m);
}


void account_action_set_ui (AccountAction* self, AuthAccounts* _ac) {
	AuthAccounts* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_ac != NULL);
	self->priv->accounts = (_tmp0_ = auth_accounts_new (), _g_object_unref0 (self->priv->accounts), _tmp0_);
	account_action_setup (self);
}


static void _lambda0_ (Block1Data* _data1_) {
	AccountAction * self;
	self = _data1_->self;
	if (gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _data1_->item)) {
		char* _tmp1_;
		char* _tmp0_;
		auth_accounts_set_active_account (self->priv->accounts, _tmp1_ = g_strconcat (_tmp0_ = g_strconcat (auth_account_get_login (_data1_->acc), auth_account_get_service (_data1_->acc), NULL), auth_account_get_proxy (_data1_->acc), NULL));
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
		g_signal_emit_by_name (self, "current-account", auth_account_get_login (_data1_->acc), auth_account_get_password (_data1_->acc), auth_account_get_service (_data1_->acc), auth_account_get_proxy (_data1_->acc));
		auth_accounts_write (self->priv->accounts);
	}
}


static void __lambda0__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender, gpointer self) {
	_lambda0_ (self);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	++_data1_->_ref_count_;
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if ((--_data1_->_ref_count_) == 0) {
		_g_object_unref0 (_data1_->self);
		_g_object_unref0 (_data1_->acc);
		_g_object_unref0 (_data1_->item);
		g_slice_free (Block1Data, _data1_);
	}
}


static void account_action_setup (AccountAction* self) {
	GtkMenu* _tmp0_;
	GSList* group;
	g_return_if_fail (self != NULL);
	self->priv->menu = (_tmp0_ = g_object_ref_sink ((GtkMenu*) gtk_menu_new ()), _g_object_unref0 (self->priv->menu), _tmp0_);
	group = NULL;
	{
		GeeIterator* _acc_it;
		_acc_it = gee_abstract_collection_iterator ((GeeAbstractCollection*) auth_accounts_get_accounts (self->priv->accounts));
		while (TRUE) {
			Block1Data* _data1_;
			char* _tmp1_;
			GtkRadioMenuItem* _tmp2_;
			_data1_ = g_slice_new0 (Block1Data);
			_data1_->_ref_count_ = 1;
			_data1_->self = g_object_ref (self);
			if (!gee_iterator_next (_acc_it)) {
				block1_data_unref (_data1_);
				break;
			}
			_data1_->acc = (AuthAccount*) gee_iterator_get (_acc_it);
			_data1_->item = (_tmp2_ = g_object_ref_sink ((GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (group, _tmp1_ = g_strdup_printf ("%s (%s)", auth_account_get_login (_data1_->acc), auth_account_get_service (_data1_->acc)))), _g_free0 (_tmp1_), _tmp2_);
			group = gtk_radio_menu_item_get_group (_data1_->item);
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _data1_->item, auth_account_get_active (_data1_->acc));
			g_signal_connect_data ((GtkCheckMenuItem*) _data1_->item, "toggled", (GCallback) __lambda0__gtk_check_menu_item_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
			gtk_menu_shell_append ((GtkMenuShell*) self->priv->menu, (GtkWidget*) ((GtkMenuItem*) _data1_->item));
			if (auth_account_get_active (_data1_->acc) | (gee_collection_get_size ((GeeCollection*) auth_accounts_get_accounts (self->priv->accounts)) == 1)) {
				g_signal_emit_by_name (self, "current-account", auth_account_get_login (_data1_->acc), auth_account_get_password (_data1_->acc), auth_account_get_service (_data1_->acc), auth_account_get_proxy (_data1_->acc));
			}
			block1_data_unref (_data1_);
		}
		_g_object_unref0 (_acc_it);
	}
	gtk_menu_item_set_submenu (self->priv->menu_item, (GtkWidget*) self->priv->menu);
	gtk_widget_show_all ((GtkWidget*) self->priv->menu);
}


static void _lambda1_ (AccountAction* self) {
	account_action_setup (self);
}


static void __lambda1__auth_accounts_changed (AuthAccounts* _sender, const char* hash, gpointer self) {
	_lambda1_ (self);
}


static void _account_action_acc_changed_auth_accounts_active_changed (AuthAccounts* _sender, gpointer self) {
	account_action_acc_changed (self);
}


void account_action_set_accounts (AccountAction* self, AuthAccounts* _accounts) {
	AuthAccounts* _tmp0_;
	AuthAccount* acc;
	char* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_accounts != NULL);
	self->priv->accounts = (_tmp0_ = _g_object_ref0 (_accounts), _g_object_unref0 (self->priv->accounts), _tmp0_);
	acc = auth_accounts_get_current_account (self->priv->accounts);
	g_signal_connect_object (self->priv->accounts, "changed", (GCallback) __lambda1__auth_accounts_changed, self, 0);
	g_signal_connect_object (self->priv->accounts, "active-changed", (GCallback) _account_action_acc_changed_auth_accounts_active_changed, self, 0);
	gtk_action_set_tooltip ((GtkAction*) self, _tmp1_ = g_strdup_printf ("%s (%s)", auth_account_get_login (acc), auth_account_get_service (acc)));
	_g_free0 (_tmp1_);
	_g_object_unref0 (acc);
}


void account_action_acc_changed (AccountAction* self) {
	AuthAccount* acc;
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	acc = auth_accounts_get_current_account (self->priv->accounts);
	g_signal_emit_by_name (self, "current-account", auth_account_get_login (acc), auth_account_get_password (acc), auth_account_get_service (acc), auth_account_get_proxy (acc));
	gtk_action_set_tooltip ((GtkAction*) self, _tmp0_ = g_strdup_printf ("%s (%s)", auth_account_get_login (acc), auth_account_get_service (acc)));
	_g_free0 (_tmp0_);
	_g_object_unref0 (acc);
}


static void account_action_class_init (AccountActionClass * klass) {
	account_action_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AccountActionPrivate));
	G_OBJECT_CLASS (klass)->finalize = account_action_finalize;
	g_signal_new ("current_account", TYPE_ACCOUNT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING, G_TYPE_NONE, 4, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
}


static void account_action_instance_init (AccountAction * self) {
	self->priv = ACCOUNT_ACTION_GET_PRIVATE (self);
}


static void account_action_finalize (GObject* obj) {
	AccountAction * self;
	self = ACCOUNT_ACTION (obj);
	_g_object_unref0 (self->priv->accounts);
	_g_object_unref0 (self->priv->menu_item);
	_g_object_unref0 (self->priv->menu);
	G_OBJECT_CLASS (account_action_parent_class)->finalize (obj);
}


GType account_action_get_type (void) {
	static volatile gsize account_action_type_id__volatile = 0;
	if (g_once_init_enter (&account_action_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) account_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountAction), 0, (GInstanceInitFunc) account_action_instance_init, NULL };
		GType account_action_type_id;
		account_action_type_id = g_type_register_static (GTK_TYPE_ACTION, "AccountAction", &g_define_type_info, 0);
		g_once_init_leave (&account_action_type_id__volatile, account_action_type_id);
	}
	return account_action_type_id__volatile;
}



static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, const char* arg_4, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), g_value_get_string (param_values + 4), data2);
}



