/* pref_dialog.c generated by valac, the Vala compiler
 * generated from pref_dialog.vala, do not modify */

/* pref_dialog.vala
 *
 * Copyright (C) 2009-2010  troorl
 * Copyright (C) 2010 Kushal Das <kushal@fedoraproject.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_PREF_DIALOG (pref_dialog_get_type ())
#define PREF_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREF_DIALOG, PrefDialog))
#define PREF_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREF_DIALOG, PrefDialogClass))
#define IS_PREF_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREF_DIALOG))
#define IS_PREF_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREF_DIALOG))
#define PREF_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREF_DIALOG, PrefDialogClass))

typedef struct _PrefDialog PrefDialog;
typedef struct _PrefDialogClass PrefDialogClass;
typedef struct _PrefDialogPrivate PrefDialogPrivate;

#define TYPE_ACCOUNT_WIDGET (account_widget_get_type ())
#define ACCOUNT_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT_WIDGET, AccountWidget))
#define ACCOUNT_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT_WIDGET, AccountWidgetClass))
#define IS_ACCOUNT_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT_WIDGET))
#define IS_ACCOUNT_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT_WIDGET))
#define ACCOUNT_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT_WIDGET, AccountWidgetClass))

typedef struct _AccountWidget AccountWidget;
typedef struct _AccountWidgetClass AccountWidgetClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define AUTH_TYPE_ACCOUNTS (auth_accounts_get_type ())
#define AUTH_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUTH_TYPE_ACCOUNTS, AuthAccounts))
#define AUTH_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUTH_TYPE_ACCOUNTS, AuthAccountsClass))
#define AUTH_IS_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUTH_TYPE_ACCOUNTS))
#define AUTH_IS_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUTH_TYPE_ACCOUNTS))
#define AUTH_ACCOUNTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUTH_TYPE_ACCOUNTS, AuthAccountsClass))

typedef struct _AuthAccounts AuthAccounts;
typedef struct _AuthAccountsClass AuthAccountsClass;

#define TYPE_HIG_TABLE (hig_table_get_type ())
#define HIG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIG_TABLE, HigTable))
#define HIG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIG_TABLE, HigTableClass))
#define IS_HIG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIG_TABLE))
#define IS_HIG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIG_TABLE))
#define HIG_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIG_TABLE, HigTableClass))

typedef struct _HigTable HigTable;
typedef struct _HigTableClass HigTableClass;

struct _PrefDialog {
	GtkDialog parent_instance;
	PrefDialogPrivate * priv;
	AccountWidget* accountWidget;
};

struct _PrefDialogClass {
	GtkDialogClass parent_class;
};

struct _PrefDialogPrivate {
	GtkNotebook* tabs;
	GtkEntry* login;
	GtkEntry* password;
	GtkCheckButton* savePass;
};


static gpointer pref_dialog_parent_class = NULL;

GType pref_dialog_get_type (void);
GType account_widget_get_type (void);
#define PREF_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREF_DIALOG, PrefDialogPrivate))
enum  {
	PREF_DIALOG_DUMMY_PROPERTY
};
GType auth_accounts_get_type (void);
AccountWidget* account_widget_new (GtkWindow* _parent, AuthAccounts* _accounts);
AccountWidget* account_widget_construct (GType object_type, GtkWindow* _parent, AuthAccounts* _accounts);
HigTable* hig_table_new (const char* title);
HigTable* hig_table_construct (GType object_type, const char* title);
GType hig_table_get_type (void);
void hig_table_add_widget_wide (HigTable* self, GtkWidget* w);
static void pref_dialog_response_acts (PrefDialog* self, gint resp_id);
static void _pref_dialog_response_acts_gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
PrefDialog* pref_dialog_new (GtkWindow* parent, AuthAccounts* accounts);
PrefDialog* pref_dialog_construct (GType object_type, GtkWindow* parent, AuthAccounts* accounts);
static void pref_dialog_finalize (GObject* obj);



static void _pref_dialog_response_acts_gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
	pref_dialog_response_acts (self, response_id);
}


PrefDialog* pref_dialog_construct (GType object_type, GtkWindow* parent, AuthAccounts* accounts) {
	PrefDialog * self;
	GtkNotebook* _tmp0_;
	GtkVBox* ac_box;
	AccountWidget* _tmp1_;
	HigTable* table_auth;
	GtkLabel* _tmp2_;
	GtkHBox* hor_box;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (accounts != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	gtk_window_set_title ((GtkWindow*) self, _ ("Preferences"));
	gtk_dialog_set_has_separator ((GtkDialog*) self, FALSE);
	self->priv->tabs = (_tmp0_ = g_object_ref_sink ((GtkNotebook*) gtk_notebook_new ()), _g_object_unref0 (self->priv->tabs), _tmp0_);
	ac_box = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
	self->accountWidget = (_tmp1_ = g_object_ref_sink (account_widget_new ((GtkWindow*) self, accounts)), _g_object_unref0 (self->accountWidget), _tmp1_);
	table_auth = g_object_ref_sink (hig_table_new (_ ("Authorization")));
	hig_table_add_widget_wide (table_auth, (GtkWidget*) self->accountWidget);
	gtk_box_pack_start ((GtkBox*) ac_box, (GtkWidget*) table_auth, FALSE, TRUE, (guint) 10);
	gtk_notebook_append_page (self->priv->tabs, (GtkWidget*) ac_box, (GtkWidget*) (_tmp2_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Account")))));
	_g_object_unref0 (_tmp2_);
	hor_box = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
	gtk_box_pack_start ((GtkBox*) hor_box, (GtkWidget*) self->priv->tabs, TRUE, TRUE, (guint) 10);
	gtk_box_pack_start ((GtkBox*) ((GtkDialog*) self)->vbox, (GtkWidget*) hor_box, TRUE, TRUE, (guint) 10);
	gtk_box_set_spacing ((GtkBox*) ((GtkDialog*) self)->vbox, 0);
	gtk_dialog_add_button ((GtkDialog*) self, GTK_STOCK_CLOSE, (gint) GTK_RESPONSE_CLOSE);
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) _pref_dialog_response_acts_gtk_dialog_response, self, 0);
	gtk_window_set_transient_for ((GtkWindow*) self, parent);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (ac_box);
	_g_object_unref0 (table_auth);
	_g_object_unref0 (hor_box);
	return self;
}


PrefDialog* pref_dialog_new (GtkWindow* parent, AuthAccounts* accounts) {
	return pref_dialog_construct (TYPE_PREF_DIALOG, parent, accounts);
}


static void pref_dialog_response_acts (PrefDialog* self, gint resp_id) {
	g_return_if_fail (self != NULL);
	switch (resp_id) {
		case GTK_RESPONSE_CLOSE:
		{
			g_signal_emit_by_name ((GtkDialog*) self, "close");
			break;
		}
	}
}


static void pref_dialog_class_init (PrefDialogClass * klass) {
	pref_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PrefDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = pref_dialog_finalize;
	g_signal_new ("delete_cache", TYPE_PREF_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void pref_dialog_instance_init (PrefDialog * self) {
	self->priv = PREF_DIALOG_GET_PRIVATE (self);
}


static void pref_dialog_finalize (GObject* obj) {
	PrefDialog * self;
	self = PREF_DIALOG (obj);
	_g_object_unref0 (self->priv->tabs);
	_g_object_unref0 (self->priv->login);
	_g_object_unref0 (self->priv->password);
	_g_object_unref0 (self->priv->savePass);
	_g_object_unref0 (self->accountWidget);
	G_OBJECT_CLASS (pref_dialog_parent_class)->finalize (obj);
}


GType pref_dialog_get_type (void) {
	static volatile gsize pref_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&pref_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrefDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pref_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrefDialog), 0, (GInstanceInitFunc) pref_dialog_instance_init, NULL };
		GType pref_dialog_type_id;
		pref_dialog_type_id = g_type_register_static (GTK_TYPE_DIALOG, "PrefDialog", &g_define_type_info, 0);
		g_once_init_leave (&pref_dialog_type_id__volatile, pref_dialog_type_id);
	}
	return pref_dialog_type_id__volatile;
}




